t / test-lib.shon commit Merge branch 'maint-1.7.8' into maint (80a3f53)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45# A call to "unset" with no arguments causes at least Solaris 10
  46# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  47# deriving from the command substitution clustered with the other
  48# ones.
  49unset VISUAL EMAIL LANGUAGE $(perl -e '
  50        my @env = keys %ENV;
  51        my $ok = join("|", qw(
  52                TRACE
  53                DEBUG
  54                USE_LOOKUP
  55                TEST
  56                .*_TEST
  57                PROVE
  58                VALGRIND
  59        ));
  60        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  61        print join("\n", @vars);
  62')
  63GIT_AUTHOR_EMAIL=author@example.com
  64GIT_AUTHOR_NAME='A U Thor'
  65GIT_COMMITTER_EMAIL=committer@example.com
  66GIT_COMMITTER_NAME='C O Mitter'
  67GIT_MERGE_VERBOSITY=5
  68export GIT_MERGE_VERBOSITY
  69export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  70export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  71export EDITOR
  72
  73# Protect ourselves from common misconfiguration to export
  74# CDPATH into the environment
  75unset CDPATH
  76
  77unset GREP_OPTIONS
  78
  79case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  80        1|2|true)
  81                echo "* warning: Some tests will not work if GIT_TRACE" \
  82                        "is set as to trace on STDERR ! *"
  83                echo "* warning: Please set GIT_TRACE to something" \
  84                        "other than 1, 2 or true ! *"
  85                ;;
  86esac
  87
  88# Convenience
  89#
  90# A regexp to match 5 and 40 hexdigits
  91_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  92_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  93
  94# Zero SHA-1
  95_z40=0000000000000000000000000000000000000000
  96
  97# Line feed
  98LF='
  99'
 100
 101# Each test should start with something like this, after copyright notices:
 102#
 103# test_description='Description of this test...
 104# This test checks if command xyzzy does the right thing...
 105# '
 106# . ./test-lib.sh
 107[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 108                TERM=$ORIGINAL_TERM &&
 109                export TERM &&
 110                [ -t 1 ] &&
 111                tput bold >/dev/null 2>&1 &&
 112                tput setaf 1 >/dev/null 2>&1 &&
 113                tput sgr0 >/dev/null 2>&1
 114        ) &&
 115        color=t
 116
 117while test "$#" -ne 0
 118do
 119        case "$1" in
 120        -d|--d|--de|--deb|--debu|--debug)
 121                debug=t; shift ;;
 122        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 123                immediate=t; shift ;;
 124        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 125                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 126        -h|--h|--he|--hel|--help)
 127                help=t; shift ;;
 128        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 129                verbose=t; shift ;;
 130        -q|--q|--qu|--qui|--quie|--quiet)
 131                # Ignore --quiet under a TAP::Harness. Saying how many tests
 132                # passed without the ok/not ok details is always an error.
 133                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 134        --with-dashes)
 135                with_dashes=t; shift ;;
 136        --no-color)
 137                color=; shift ;;
 138        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 139                valgrind=t; verbose=t; shift ;;
 140        --tee)
 141                shift ;; # was handled already
 142        --root=*)
 143                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 144                shift ;;
 145        *)
 146                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 147        esac
 148done
 149
 150if test -n "$color"; then
 151        say_color () {
 152                (
 153                TERM=$ORIGINAL_TERM
 154                export TERM
 155                case "$1" in
 156                        error) tput bold; tput setaf 1;; # bold red
 157                        skip)  tput bold; tput setaf 2;; # bold green
 158                        pass)  tput setaf 2;;            # green
 159                        info)  tput setaf 3;;            # brown
 160                        *) test -n "$quiet" && return;;
 161                esac
 162                shift
 163                printf "%s" "$*"
 164                tput sgr0
 165                echo
 166                )
 167        }
 168else
 169        say_color() {
 170                test -z "$1" && test -n "$quiet" && return
 171                shift
 172                echo "$*"
 173        }
 174fi
 175
 176error () {
 177        say_color error "error: $*"
 178        GIT_EXIT_OK=t
 179        exit 1
 180}
 181
 182say () {
 183        say_color info "$*"
 184}
 185
 186test "${test_description}" != "" ||
 187error "Test script did not set test_description."
 188
 189if test "$help" = "t"
 190then
 191        echo "$test_description"
 192        exit 0
 193fi
 194
 195exec 5>&1
 196exec 6<&0
 197if test "$verbose" = "t"
 198then
 199        exec 4>&2 3>&1
 200else
 201        exec 4>/dev/null 3>/dev/null
 202fi
 203
 204test_failure=0
 205test_count=0
 206test_fixed=0
 207test_broken=0
 208test_success=0
 209
 210test_external_has_tap=0
 211
 212die () {
 213        code=$?
 214        if test -n "$GIT_EXIT_OK"
 215        then
 216                exit $code
 217        else
 218                echo >&5 "FATAL: Unexpected exit with code $code"
 219                exit 1
 220        fi
 221}
 222
 223GIT_EXIT_OK=
 224trap 'die' EXIT
 225
 226# The semantics of the editor variables are that of invoking
 227# sh -c "$EDITOR \"$@\"" files ...
 228#
 229# If our trash directory contains shell metacharacters, they will be
 230# interpreted if we just set $EDITOR directly, so do a little dance with
 231# environment variables to work around this.
 232#
 233# In particular, quoting isn't enough, as the path may contain the same quote
 234# that we're using.
 235test_set_editor () {
 236        FAKE_EDITOR="$1"
 237        export FAKE_EDITOR
 238        EDITOR='"$FAKE_EDITOR"'
 239        export EDITOR
 240}
 241
 242test_decode_color () {
 243        awk '
 244                function name(n) {
 245                        if (n == 0) return "RESET";
 246                        if (n == 1) return "BOLD";
 247                        if (n == 30) return "BLACK";
 248                        if (n == 31) return "RED";
 249                        if (n == 32) return "GREEN";
 250                        if (n == 33) return "YELLOW";
 251                        if (n == 34) return "BLUE";
 252                        if (n == 35) return "MAGENTA";
 253                        if (n == 36) return "CYAN";
 254                        if (n == 37) return "WHITE";
 255                        if (n == 40) return "BLACK";
 256                        if (n == 41) return "BRED";
 257                        if (n == 42) return "BGREEN";
 258                        if (n == 43) return "BYELLOW";
 259                        if (n == 44) return "BBLUE";
 260                        if (n == 45) return "BMAGENTA";
 261                        if (n == 46) return "BCYAN";
 262                        if (n == 47) return "BWHITE";
 263                }
 264                {
 265                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 266                                printf "%s<", substr($0, 1, RSTART-1);
 267                                codes = substr($0, RSTART+2, RLENGTH-3);
 268                                if (length(codes) == 0)
 269                                        printf "%s", name(0)
 270                                else {
 271                                        n = split(codes, ary, ";");
 272                                        sep = "";
 273                                        for (i = 1; i <= n; i++) {
 274                                                printf "%s%s", sep, name(ary[i]);
 275                                                sep = ";"
 276                                        }
 277                                }
 278                                printf ">";
 279                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 280                        }
 281                        print
 282                }
 283        '
 284}
 285
 286nul_to_q () {
 287        perl -pe 'y/\000/Q/'
 288}
 289
 290q_to_nul () {
 291        perl -pe 'y/Q/\000/'
 292}
 293
 294q_to_cr () {
 295        tr Q '\015'
 296}
 297
 298q_to_tab () {
 299        tr Q '\011'
 300}
 301
 302append_cr () {
 303        sed -e 's/$/Q/' | tr Q '\015'
 304}
 305
 306remove_cr () {
 307        tr '\015' Q | sed -e 's/Q$//'
 308}
 309
 310# In some bourne shell implementations, the "unset" builtin returns
 311# nonzero status when a variable to be unset was not set in the first
 312# place.
 313#
 314# Use sane_unset when that should not be considered an error.
 315
 316sane_unset () {
 317        unset "$@"
 318        return 0
 319}
 320
 321test_tick () {
 322        if test -z "${test_tick+set}"
 323        then
 324                test_tick=1112911993
 325        else
 326                test_tick=$(($test_tick + 60))
 327        fi
 328        GIT_COMMITTER_DATE="$test_tick -0700"
 329        GIT_AUTHOR_DATE="$test_tick -0700"
 330        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 331}
 332
 333# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 334#
 335# This will commit a file with the given contents and the given commit
 336# message.  It will also add a tag with <message> as name.
 337#
 338# Both <file> and <contents> default to <message>.
 339
 340test_commit () {
 341        file=${2:-"$1.t"}
 342        echo "${3-$1}" > "$file" &&
 343        git add "$file" &&
 344        test_tick &&
 345        git commit -m "$1" &&
 346        git tag "$1"
 347}
 348
 349# Call test_merge with the arguments "<message> <commit>", where <commit>
 350# can be a tag pointing to the commit-to-merge.
 351
 352test_merge () {
 353        test_tick &&
 354        git merge -m "$1" "$2" &&
 355        git tag "$1"
 356}
 357
 358# This function helps systems where core.filemode=false is set.
 359# Use it instead of plain 'chmod +x' to set or unset the executable bit
 360# of a file in the working directory and add it to the index.
 361
 362test_chmod () {
 363        chmod "$@" &&
 364        git update-index --add "--chmod=$@"
 365}
 366
 367# Unset a configuration variable, but don't fail if it doesn't exist.
 368test_unconfig () {
 369        git config --unset-all "$@"
 370        config_status=$?
 371        case "$config_status" in
 372        5) # ok, nothing to unset
 373                config_status=0
 374                ;;
 375        esac
 376        return $config_status
 377}
 378
 379# Set git config, automatically unsetting it after the test is over.
 380test_config () {
 381        test_when_finished "test_unconfig '$1'" &&
 382        git config "$@"
 383}
 384
 385
 386test_config_global () {
 387        test_when_finished "test_unconfig --global '$1'" &&
 388        git config --global "$@"
 389}
 390
 391write_script () {
 392        {
 393                echo "#!${2-"$SHELL_PATH"}" &&
 394                cat
 395        } >"$1" &&
 396        chmod +x "$1"
 397}
 398
 399# Use test_set_prereq to tell that a particular prerequisite is available.
 400# The prerequisite can later be checked for in two ways:
 401#
 402# - Explicitly using test_have_prereq.
 403#
 404# - Implicitly by specifying the prerequisite tag in the calls to
 405#   test_expect_{success,failure,code}.
 406#
 407# The single parameter is the prerequisite tag (a simple word, in all
 408# capital letters by convention).
 409
 410test_set_prereq () {
 411        satisfied="$satisfied$1 "
 412}
 413satisfied=" "
 414
 415test_have_prereq () {
 416        # prerequisites can be concatenated with ','
 417        save_IFS=$IFS
 418        IFS=,
 419        set -- $*
 420        IFS=$save_IFS
 421
 422        total_prereq=0
 423        ok_prereq=0
 424        missing_prereq=
 425
 426        for prerequisite
 427        do
 428                total_prereq=$(($total_prereq + 1))
 429                case $satisfied in
 430                *" $prerequisite "*)
 431                        ok_prereq=$(($ok_prereq + 1))
 432                        ;;
 433                *)
 434                        # Keep a list of missing prerequisites
 435                        if test -z "$missing_prereq"
 436                        then
 437                                missing_prereq=$prerequisite
 438                        else
 439                                missing_prereq="$prerequisite,$missing_prereq"
 440                        fi
 441                esac
 442        done
 443
 444        test $total_prereq = $ok_prereq
 445}
 446
 447test_declared_prereq () {
 448        case ",$test_prereq," in
 449        *,$1,*)
 450                return 0
 451                ;;
 452        esac
 453        return 1
 454}
 455
 456# You are not expected to call test_ok_ and test_failure_ directly, use
 457# the text_expect_* functions instead.
 458
 459test_ok_ () {
 460        test_success=$(($test_success + 1))
 461        say_color "" "ok $test_count - $@"
 462}
 463
 464test_failure_ () {
 465        test_failure=$(($test_failure + 1))
 466        say_color error "not ok - $test_count $1"
 467        shift
 468        echo "$@" | sed -e 's/^/#       /'
 469        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 470}
 471
 472test_known_broken_ok_ () {
 473        test_fixed=$(($test_fixed+1))
 474        say_color "" "ok $test_count - $@ # TODO known breakage"
 475}
 476
 477test_known_broken_failure_ () {
 478        test_broken=$(($test_broken+1))
 479        say_color skip "not ok $test_count - $@ # TODO known breakage"
 480}
 481
 482test_debug () {
 483        test "$debug" = "" || eval "$1"
 484}
 485
 486test_eval_ () {
 487        # This is a separate function because some tests use
 488        # "return" to end a test_expect_success block early.
 489        eval </dev/null >&3 2>&4 "$*"
 490}
 491
 492test_run_ () {
 493        test_cleanup=:
 494        expecting_failure=$2
 495        test_eval_ "$1"
 496        eval_ret=$?
 497
 498        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 499        then
 500                test_eval_ "$test_cleanup"
 501        fi
 502        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 503                echo ""
 504        fi
 505        return "$eval_ret"
 506}
 507
 508test_skip () {
 509        test_count=$(($test_count+1))
 510        to_skip=
 511        for skp in $GIT_SKIP_TESTS
 512        do
 513                case $this_test.$test_count in
 514                $skp)
 515                        to_skip=t
 516                        break
 517                esac
 518        done
 519        if test -z "$to_skip" && test -n "$test_prereq" &&
 520           ! test_have_prereq "$test_prereq"
 521        then
 522                to_skip=t
 523        fi
 524        case "$to_skip" in
 525        t)
 526                of_prereq=
 527                if test "$missing_prereq" != "$test_prereq"
 528                then
 529                        of_prereq=" of $test_prereq"
 530                fi
 531
 532                say_color skip >&3 "skipping test: $@"
 533                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 534                : true
 535                ;;
 536        *)
 537                false
 538                ;;
 539        esac
 540}
 541
 542test_expect_failure () {
 543        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 544        test "$#" = 2 ||
 545        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 546        export test_prereq
 547        if ! test_skip "$@"
 548        then
 549                say >&3 "checking known breakage: $2"
 550                if test_run_ "$2" expecting_failure
 551                then
 552                        test_known_broken_ok_ "$1"
 553                else
 554                        test_known_broken_failure_ "$1"
 555                fi
 556        fi
 557        echo >&3 ""
 558}
 559
 560test_expect_success () {
 561        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 562        test "$#" = 2 ||
 563        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 564        export test_prereq
 565        if ! test_skip "$@"
 566        then
 567                say >&3 "expecting success: $2"
 568                if test_run_ "$2"
 569                then
 570                        test_ok_ "$1"
 571                else
 572                        test_failure_ "$@"
 573                fi
 574        fi
 575        echo >&3 ""
 576}
 577
 578# test_external runs external test scripts that provide continuous
 579# test output about their progress, and succeeds/fails on
 580# zero/non-zero exit code.  It outputs the test output on stdout even
 581# in non-verbose mode, and announces the external script with "# run
 582# <n>: ..." before running it.  When providing relative paths, keep in
 583# mind that all scripts run in "trash directory".
 584# Usage: test_external description command arguments...
 585# Example: test_external 'Perl API' perl ../path/to/test.pl
 586test_external () {
 587        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 588        test "$#" = 3 ||
 589        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 590        descr="$1"
 591        shift
 592        export test_prereq
 593        if ! test_skip "$descr" "$@"
 594        then
 595                # Announce the script to reduce confusion about the
 596                # test output that follows.
 597                say_color "" "# run $test_count: $descr ($*)"
 598                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 599                # to be able to use them in script
 600                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 601                # Run command; redirect its stderr to &4 as in
 602                # test_run_, but keep its stdout on our stdout even in
 603                # non-verbose mode.
 604                "$@" 2>&4
 605                if [ "$?" = 0 ]
 606                then
 607                        if test $test_external_has_tap -eq 0; then
 608                                test_ok_ "$descr"
 609                        else
 610                                say_color "" "# test_external test $descr was ok"
 611                                test_success=$(($test_success + 1))
 612                        fi
 613                else
 614                        if test $test_external_has_tap -eq 0; then
 615                                test_failure_ "$descr" "$@"
 616                        else
 617                                say_color error "# test_external test $descr failed: $@"
 618                                test_failure=$(($test_failure + 1))
 619                        fi
 620                fi
 621        fi
 622}
 623
 624# Like test_external, but in addition tests that the command generated
 625# no output on stderr.
 626test_external_without_stderr () {
 627        # The temporary file has no (and must have no) security
 628        # implications.
 629        tmp=${TMPDIR:-/tmp}
 630        stderr="$tmp/git-external-stderr.$$.tmp"
 631        test_external "$@" 4> "$stderr"
 632        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 633        descr="no stderr: $1"
 634        shift
 635        say >&3 "# expecting no stderr from previous command"
 636        if [ ! -s "$stderr" ]; then
 637                rm "$stderr"
 638
 639                if test $test_external_has_tap -eq 0; then
 640                        test_ok_ "$descr"
 641                else
 642                        say_color "" "# test_external_without_stderr test $descr was ok"
 643                        test_success=$(($test_success + 1))
 644                fi
 645        else
 646                if [ "$verbose" = t ]; then
 647                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 648                else
 649                        output=
 650                fi
 651                # rm first in case test_failure exits.
 652                rm "$stderr"
 653                if test $test_external_has_tap -eq 0; then
 654                        test_failure_ "$descr" "$@" "$output"
 655                else
 656                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 657                        test_failure=$(($test_failure + 1))
 658                fi
 659        fi
 660}
 661
 662# debugging-friendly alternatives to "test [-f|-d|-e]"
 663# The commands test the existence or non-existence of $1. $2 can be
 664# given to provide a more precise diagnosis.
 665test_path_is_file () {
 666        if ! [ -f "$1" ]
 667        then
 668                echo "File $1 doesn't exist. $*"
 669                false
 670        fi
 671}
 672
 673test_path_is_dir () {
 674        if ! [ -d "$1" ]
 675        then
 676                echo "Directory $1 doesn't exist. $*"
 677                false
 678        fi
 679}
 680
 681test_path_is_missing () {
 682        if [ -e "$1" ]
 683        then
 684                echo "Path exists:"
 685                ls -ld "$1"
 686                if [ $# -ge 1 ]; then
 687                        echo "$*"
 688                fi
 689                false
 690        fi
 691}
 692
 693# test_line_count checks that a file has the number of lines it
 694# ought to. For example:
 695#
 696#       test_expect_success 'produce exactly one line of output' '
 697#               do something >output &&
 698#               test_line_count = 1 output
 699#       '
 700#
 701# is like "test $(wc -l <output) = 1" except that it passes the
 702# output through when the number of lines is wrong.
 703
 704test_line_count () {
 705        if test $# != 3
 706        then
 707                error "bug in the test script: not 3 parameters to test_line_count"
 708        elif ! test $(wc -l <"$3") "$1" "$2"
 709        then
 710                echo "test_line_count: line count for $3 !$1 $2"
 711                cat "$3"
 712                return 1
 713        fi
 714}
 715
 716# This is not among top-level (test_expect_success | test_expect_failure)
 717# but is a prefix that can be used in the test script, like:
 718#
 719#       test_expect_success 'complain and die' '
 720#           do something &&
 721#           do something else &&
 722#           test_must_fail git checkout ../outerspace
 723#       '
 724#
 725# Writing this as "! git checkout ../outerspace" is wrong, because
 726# the failure could be due to a segv.  We want a controlled failure.
 727
 728test_must_fail () {
 729        "$@"
 730        exit_code=$?
 731        if test $exit_code = 0; then
 732                echo >&2 "test_must_fail: command succeeded: $*"
 733                return 1
 734        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 735                echo >&2 "test_must_fail: died by signal: $*"
 736                return 1
 737        elif test $exit_code = 127; then
 738                echo >&2 "test_must_fail: command not found: $*"
 739                return 1
 740        fi
 741        return 0
 742}
 743
 744# Similar to test_must_fail, but tolerates success, too.  This is
 745# meant to be used in contexts like:
 746#
 747#       test_expect_success 'some command works without configuration' '
 748#               test_might_fail git config --unset all.configuration &&
 749#               do something
 750#       '
 751#
 752# Writing "git config --unset all.configuration || :" would be wrong,
 753# because we want to notice if it fails due to segv.
 754
 755test_might_fail () {
 756        "$@"
 757        exit_code=$?
 758        if test $exit_code -gt 129 -a $exit_code -le 192; then
 759                echo >&2 "test_might_fail: died by signal: $*"
 760                return 1
 761        elif test $exit_code = 127; then
 762                echo >&2 "test_might_fail: command not found: $*"
 763                return 1
 764        fi
 765        return 0
 766}
 767
 768# Similar to test_must_fail and test_might_fail, but check that a
 769# given command exited with a given exit code. Meant to be used as:
 770#
 771#       test_expect_success 'Merge with d/f conflicts' '
 772#               test_expect_code 1 git merge "merge msg" B master
 773#       '
 774
 775test_expect_code () {
 776        want_code=$1
 777        shift
 778        "$@"
 779        exit_code=$?
 780        if test $exit_code = $want_code
 781        then
 782                return 0
 783        fi
 784
 785        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 786        return 1
 787}
 788
 789# test_cmp is a helper function to compare actual and expected output.
 790# You can use it like:
 791#
 792#       test_expect_success 'foo works' '
 793#               echo expected >expected &&
 794#               foo >actual &&
 795#               test_cmp expected actual
 796#       '
 797#
 798# This could be written as either "cmp" or "diff -u", but:
 799# - cmp's output is not nearly as easy to read as diff -u
 800# - not all diff versions understand "-u"
 801
 802test_cmp() {
 803        $GIT_TEST_CMP "$@"
 804}
 805
 806# This function can be used to schedule some commands to be run
 807# unconditionally at the end of the test to restore sanity:
 808#
 809#       test_expect_success 'test core.capslock' '
 810#               git config core.capslock true &&
 811#               test_when_finished "git config --unset core.capslock" &&
 812#               hello world
 813#       '
 814#
 815# That would be roughly equivalent to
 816#
 817#       test_expect_success 'test core.capslock' '
 818#               git config core.capslock true &&
 819#               hello world
 820#               git config --unset core.capslock
 821#       '
 822#
 823# except that the greeting and config --unset must both succeed for
 824# the test to pass.
 825#
 826# Note that under --immediate mode, no clean-up is done to help diagnose
 827# what went wrong.
 828
 829test_when_finished () {
 830        test_cleanup="{ $*
 831                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 832}
 833
 834# Most tests can use the created repository, but some may need to create more.
 835# Usage: test_create_repo <directory>
 836test_create_repo () {
 837        test "$#" = 1 ||
 838        error "bug in the test script: not 1 parameter to test-create-repo"
 839        repo="$1"
 840        mkdir -p "$repo"
 841        (
 842                cd "$repo" || error "Cannot setup test environment"
 843                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 844                error "cannot run git init -- have you built things yet?"
 845                mv .git/hooks .git/hooks-disabled
 846        ) || exit
 847}
 848
 849test_done () {
 850        GIT_EXIT_OK=t
 851
 852        if test -z "$HARNESS_ACTIVE"; then
 853                test_results_dir="$TEST_DIRECTORY/test-results"
 854                mkdir -p "$test_results_dir"
 855                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 856
 857                cat >>"$test_results_path" <<-EOF
 858                total $test_count
 859                success $test_success
 860                fixed $test_fixed
 861                broken $test_broken
 862                failed $test_failure
 863
 864                EOF
 865        fi
 866
 867        if test "$test_fixed" != 0
 868        then
 869                say_color pass "# fixed $test_fixed known breakage(s)"
 870        fi
 871        if test "$test_broken" != 0
 872        then
 873                say_color error "# still have $test_broken known breakage(s)"
 874                msg="remaining $(($test_count-$test_broken)) test(s)"
 875        else
 876                msg="$test_count test(s)"
 877        fi
 878        case "$test_failure" in
 879        0)
 880                # Maybe print SKIP message
 881                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 882
 883                if test $test_external_has_tap -eq 0; then
 884                        say_color pass "# passed all $msg"
 885                        say "1..$test_count$skip_all"
 886                fi
 887
 888                test -d "$remove_trash" &&
 889                cd "$(dirname "$remove_trash")" &&
 890                rm -rf "$(basename "$remove_trash")"
 891
 892                exit 0 ;;
 893
 894        *)
 895                if test $test_external_has_tap -eq 0; then
 896                        say_color error "# failed $test_failure among $msg"
 897                        say "1..$test_count"
 898                fi
 899
 900                exit 1 ;;
 901
 902        esac
 903}
 904
 905# Test the binaries we have just built.  The tests are kept in
 906# t/ subdirectory and are run in 'trash directory' subdirectory.
 907if test -z "$TEST_DIRECTORY"
 908then
 909        # We allow tests to override this, in case they want to run tests
 910        # outside of t/, e.g. for running tests on the test library
 911        # itself.
 912        TEST_DIRECTORY=$(pwd)
 913fi
 914GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 915
 916if test -n "$valgrind"
 917then
 918        make_symlink () {
 919                test -h "$2" &&
 920                test "$1" = "$(readlink "$2")" || {
 921                        # be super paranoid
 922                        if mkdir "$2".lock
 923                        then
 924                                rm -f "$2" &&
 925                                ln -s "$1" "$2" &&
 926                                rm -r "$2".lock
 927                        else
 928                                while test -d "$2".lock
 929                                do
 930                                        say "Waiting for lock on $2."
 931                                        sleep 1
 932                                done
 933                        fi
 934                }
 935        }
 936
 937        make_valgrind_symlink () {
 938                # handle only executables, unless they are shell libraries that
 939                # need to be in the exec-path.  We will just use "#!" as a
 940                # guess for a shell-script, since we have no idea what the user
 941                # may have configured as the shell path.
 942                test -x "$1" ||
 943                test "#!" = "$(head -c 2 <"$1")" ||
 944                return;
 945
 946                base=$(basename "$1")
 947                symlink_target=$GIT_BUILD_DIR/$base
 948                # do not override scripts
 949                if test -x "$symlink_target" &&
 950                    test ! -d "$symlink_target" &&
 951                    test "#!" != "$(head -c 2 < "$symlink_target")"
 952                then
 953                        symlink_target=../valgrind.sh
 954                fi
 955                case "$base" in
 956                *.sh|*.perl)
 957                        symlink_target=../unprocessed-script
 958                esac
 959                # create the link, or replace it if it is out of date
 960                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 961        }
 962
 963        # override all git executables in TEST_DIRECTORY/..
 964        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 965        mkdir -p "$GIT_VALGRIND"/bin
 966        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 967        do
 968                make_valgrind_symlink $file
 969        done
 970        # special-case the mergetools loadables
 971        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 972        OLDIFS=$IFS
 973        IFS=:
 974        for path in $PATH
 975        do
 976                ls "$path"/git-* 2> /dev/null |
 977                while read file
 978                do
 979                        make_valgrind_symlink "$file"
 980                done
 981        done
 982        IFS=$OLDIFS
 983        PATH=$GIT_VALGRIND/bin:$PATH
 984        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 985        export GIT_VALGRIND
 986elif test -n "$GIT_TEST_INSTALLED" ; then
 987        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 988        error "Cannot run git from $GIT_TEST_INSTALLED."
 989        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 990        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 991else # normal case, use ../bin-wrappers only unless $with_dashes:
 992        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 993        if ! test -x "$git_bin_dir/git" ; then
 994                if test -z "$with_dashes" ; then
 995                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 996                fi
 997                with_dashes=t
 998        fi
 999        PATH="$git_bin_dir:$PATH"
1000        GIT_EXEC_PATH=$GIT_BUILD_DIR
1001        if test -n "$with_dashes" ; then
1002                PATH="$GIT_BUILD_DIR:$PATH"
1003        fi
1004fi
1005GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1006unset GIT_CONFIG
1007GIT_CONFIG_NOSYSTEM=1
1008GIT_ATTR_NOSYSTEM=1
1009export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1010
1011. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1012
1013if test -z "$GIT_TEST_CMP"
1014then
1015        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1016        then
1017                GIT_TEST_CMP="$DIFF -c"
1018        else
1019                GIT_TEST_CMP="$DIFF -u"
1020        fi
1021fi
1022
1023GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1024export GITPERLLIB
1025test -d "$GIT_BUILD_DIR"/templates/blt || {
1026        error "You haven't built things yet, have you?"
1027}
1028
1029if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1030then
1031        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1032        export GITPYTHONLIB
1033        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1034                error "You haven't built git_remote_helpers yet, have you?"
1035        }
1036fi
1037
1038if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1039        echo >&2 'You need to build test-chmtime:'
1040        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1041        exit 1
1042fi
1043
1044# Test repository
1045test="trash directory.$(basename "$0" .sh)"
1046test -n "$root" && test="$root/$test"
1047case "$test" in
1048/*) TRASH_DIRECTORY="$test" ;;
1049 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1050esac
1051test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1052rm -fr "$test" || {
1053        GIT_EXIT_OK=t
1054        echo >&5 "FATAL: Cannot prepare test area"
1055        exit 1
1056}
1057
1058HOME="$TRASH_DIRECTORY"
1059export HOME
1060
1061test_create_repo "$test"
1062# Use -P to resolve symlinks in our working directory so that the cwd
1063# in subprocesses like git equals our $PWD (for pathname comparisons).
1064cd -P "$test" || exit 1
1065
1066this_test=${0##*/}
1067this_test=${this_test%%-*}
1068for skp in $GIT_SKIP_TESTS
1069do
1070        case "$this_test" in
1071        $skp)
1072                say_color skip >&3 "skipping test $this_test altogether"
1073                skip_all="skip all tests in $this_test"
1074                test_done
1075        esac
1076done
1077
1078# Provide an implementation of the 'yes' utility
1079yes () {
1080        if test $# = 0
1081        then
1082                y=y
1083        else
1084                y="$*"
1085        fi
1086
1087        while echo "$y"
1088        do
1089                :
1090        done
1091}
1092
1093# Fix some commands on Windows
1094case $(uname -s) in
1095*MINGW*)
1096        # Windows has its own (incompatible) sort and find
1097        sort () {
1098                /usr/bin/sort "$@"
1099        }
1100        find () {
1101                /usr/bin/find "$@"
1102        }
1103        sum () {
1104                md5sum "$@"
1105        }
1106        # git sees Windows-style pwd
1107        pwd () {
1108                builtin pwd -W
1109        }
1110        # no POSIX permissions
1111        # backslashes in pathspec are converted to '/'
1112        # exec does not inherit the PID
1113        test_set_prereq MINGW
1114        test_set_prereq SED_STRIPS_CR
1115        ;;
1116*CYGWIN*)
1117        test_set_prereq POSIXPERM
1118        test_set_prereq EXECKEEPSPID
1119        test_set_prereq NOT_MINGW
1120        test_set_prereq SED_STRIPS_CR
1121        ;;
1122*)
1123        test_set_prereq POSIXPERM
1124        test_set_prereq BSLASHPSPEC
1125        test_set_prereq EXECKEEPSPID
1126        test_set_prereq NOT_MINGW
1127        ;;
1128esac
1129
1130test -z "$NO_PERL" && test_set_prereq PERL
1131test -z "$NO_PYTHON" && test_set_prereq PYTHON
1132test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1133test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1134
1135# Can we rely on git's output in the C locale?
1136if test -n "$GETTEXT_POISON"
1137then
1138        GIT_GETTEXT_POISON=YesPlease
1139        export GIT_GETTEXT_POISON
1140        test_set_prereq GETTEXT_POISON
1141else
1142        test_set_prereq C_LOCALE_OUTPUT
1143fi
1144
1145# Use this instead of test_cmp to compare files that contain expected and
1146# actual output from git commands that can be translated.  When running
1147# under GETTEXT_POISON this pretends that the command produced expected
1148# results.
1149test_i18ncmp () {
1150        test -n "$GETTEXT_POISON" || test_cmp "$@"
1151}
1152
1153# Use this instead of "grep expected-string actual" to see if the
1154# output from a git command that can be translated either contains an
1155# expected string, or does not contain an unwanted one.  When running
1156# under GETTEXT_POISON this pretends that the command produced expected
1157# results.
1158test_i18ngrep () {
1159        if test -n "$GETTEXT_POISON"
1160        then
1161            : # pretend success
1162        elif test "x!" = "x$1"
1163        then
1164                shift
1165                ! grep "$@"
1166        else
1167                grep "$@"
1168        fi
1169}
1170
1171# test whether the filesystem supports symbolic links
1172ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1173rm -f y
1174
1175# When the tests are run as root, permission tests will report that
1176# things are writable when they shouldn't be.
1177test -w / || test_set_prereq SANITY